﻿Public Class MainForm
    Private Panel As Panel
    Private Board As New Board
    Private Count As Integer
    Private rNum As Integer
    Private flag As Boolean

    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        MsgBox("スライドパズルです" & vbCrLf & "300秒以内にそろえてください！" & vbCrLf & "ヒントボタンを押すと、揃っているパネルは赤枠" & vbCrLf & "空パネルは緑枠、パネル内には画像の番号が表示されます")

        Init()

    End Sub

    Private Sub Init()

        Count = 300
        flag = True

        Randomize()

        rNum = Int(Rnd() * 9) + 1

        Dim Img As Image = Image.FromFile(Application.StartupPath & "\Images\Image" & rNum & ".jpg")
        Board.Shuffle(Img)

        btnHint.Enabled = False
        btnStart.Text = "スタート"
        PictureBox2.Image = Img
        lblTime.Text = "300秒"
        PictureBox1.Enabled = False
        PictureBox1.Invalidate()

    End Sub

    Private Sub btnStart_Click(sender As Object, e As EventArgs) Handles btnStart.Click

        If flag Then
            Timer.Start()
            btnStart.Text = "別の画像"
            btnHint.Enabled = True
            PictureBox1.Enabled = True
            flag = False
        Else
            Timer.Stop()
            btnStart.Text = "スタート"
            btnHint.Enabled = False
            PictureBox1.Enabled = False
            flag = True
            Init()
        End If

    End Sub

    Private Sub btnEnd_Click(sender As Object, e As EventArgs) Handles btnEnd.Click
        Me.Close()
    End Sub

    Private Sub Timer_Tick(sender As Object, e As EventArgs) Handles Timer.Tick

        If Count > 1 Then
            Count -= 1
        Else
            Timer.Stop()
            PictureBox1.Enabled = False
            lblTime.Text = "000秒"
        End If

        If Count \ 100 > 0 Then
            lblTime.Text = Count & "秒"
        ElseIf Count \ 10 > 0 Then
            lblTime.Text = "0" & Count & "秒"
        Else
            lblTime.Text = "00" & Count & "秒"
        End If

    End Sub

    Private Sub PictureBox1_Click(sender As Object, e As EventArgs) Handles PictureBox1.Click

        Dim Pos As Point = PictureBox1.PointToClient(Windows.Forms.Cursor.Position)

        Dim ThisPanel As Panel = Board.PanelFormPosition(Pos.X, Pos.Y)

        Board.Move(ThisPanel.Position.X, ThisPanel.Position.Y)
        PictureBox1.Invalidate()

        If Board.ChackBoard = True Then
            Timer.Stop()
            MsgBox("おめでとう！" & vbCrLf & 300 - Count & "秒でした")
            PictureBox1.Enabled = False
        End If

    End Sub

    Private Sub PictureBox1_MouseMove(sender As Object, e As MouseEventArgs) Handles PictureBox1.MouseMove

        Dim ThisPanel As Panel

        ThisPanel = Board.PanelFormPosition(e.X, e.Y)

        If Not IsNothing(ThisPanel) Then
            ThisPanel.Focus()
            PictureBox1.Invalidate()
        End If

    End Sub

    Private Sub PictureBox1_MouseLeave(sender As Object, e As EventArgs) Handles PictureBox1.MouseLeave

        For X As Integer = 0 To Board.Count - 1
            For Y As Integer = 0 To Board.Count - 1
                Board.Panels(X, Y).Focused = False
            Next
        Next

        PictureBox1.Invalidate()

    End Sub

    '描画のために必要
    Private Sub PictureBox1_Paint(sender As Object, e As PaintEventArgs) Handles PictureBox1.Paint
        Board.Draw(e.Graphics)
    End Sub

    'ヒント
    Private Sub btnHint_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnHint.MouseDown
        Board.Hint()
    End Sub
    Private Sub btnHint_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnHint.MouseUp
        Board.unHint()
    End Sub

End Class
